/***************************************************************************
                          timetableallocatehoursform.h  -  description
                             -------------------
    begin                : Tue Apr 22 2003
    copyright            : (C) 2003 by Lalescu Liviu
    email                : Please see http://lalescu.ro/liviu/ for details about contacting Liviu Lalescu (in particular, you can find here the e-mail address)
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TIMETABLEALLOCATEHOURSFORM_H
#define TIMETABLEALLOCATEHOURSFORM_H

#include "timetableallocatehoursform_template.h"
#include "genetictimetable_defs.h"
#include "genetictimetable.h"
#include "fet.h"

#include <q3combobox.h>
#include <qmessagebox.h>
#include <q3groupbox.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <q3table.h>
#include <qapplication.h>
#include <qstring.h>
#include <qthread.h>
#include <qmutex.h>

class TimeSolvingThread: public QThread{
	Q_OBJECT

public:
	void run();

signals:
	void generationComputed(int generation);
};

class TimetableAllocateHoursForm : public TimetableAllocateHoursForm_template  {
	Q_OBJECT

public:

	TimetableAllocateHoursForm();

	~TimetableAllocateHoursForm();

	void start();

	void stop();

	void write();

	void closePressed();

	void generationLogging(int generation);

	void writeSimulationResults(TimeChromosome& c);

	/**
	Function writing the students' timetable xml format, to a file
	*/
	void writeStudentsTimetableXml(const QString& xmlfilename);

	/**
	Function writing the teachers' timetable in xml format
	*/
	void writeTeachersTimetableXml(const QString& xmlfilename);


	void writeStylesheetCss(const QString& htmlfilename);

	/**
	Function writing the students' timetable html format, to a file
	(variant 1).
	Days horizontal version.
	*/
	void writeStudentsTimetableDaysHorizontalHtml(const QString& htmlfilename);

	/**
	Function writing the students' timetable html format, to a file
	(variant 1).
	Days vertical version.
	*/
	void writeStudentsTimetableDaysVerticalHtml(const QString& htmlfilename);

	/**
	Function writing the students' timetable html format, to a file
	(variant 2)
	*/
	void writeStudentsTimetableTimeHorizontalHtml(const QString& htmlfilename);

	/**
	Function writing the students' timetable html format, to a file
	(variant 2)
	*/
	void writeStudentsTimetableTimeVerticalHtml(const QString& htmlfilename);

	/**
	Function writing the teachers' timetable in html format, version 1.
	Days horizontal version
	*/
	void writeTeachersTimetableDaysHorizontalHtml(const QString& htmlfilename);

	/**
	Function writing the teachers' timetable in html format, version 1.
	Days vertical version
	*/
	void writeTeachersTimetableDaysVerticalHtml(const QString& htmlfilename);

	/**
	Function writing the teachers' timetable in html format, version 2
	*/
	void writeTeachersTimetableTimeHorizontalHtml(const QString& htmlfilename);

	/**
	Function writing the teachers' timetable in html format, version 2
	*/
	void writeTeachersTimetableTimeVerticalHtml(const QString& htmlfilename);

	void getStudentsTimetable(TimeChromosome& c);

	void getTeachersTimetable(TimeChromosome& c);

private slots:
	void activityPlaced(int na);

	void simulationFinished();

	void impossibleToSolve();
};

#endif
